import java.io.*;
import java.util.*;

public class AlexSolution {
	
	Scanner in;
	static PrintWriter out;
	
	
	static int decode(char c) {
		if ('0' <= c && c <= '9') {
			return c - '0';
		} else {
			return c - 'A' + 10;
		}
	}
	
	static class Value {
		int ar[];
		
		Value(char []str) {
			ar = new int[str.length];
			for (int i = str.length - 1; i >= 0; i--) {
				ar[ar.length - 1 - i] = decode(str[i]);
			}
		}
		
		int getValue(int pos) {
			if (pos >= ar.length) {
				return 0;
			} else {
				return ar[pos];
			}
		}
				
		int getMinBase() {
			int ans = 0;
			for (int x : ar) {
				ans = Math.max(x + 1, ans);
			}
			return ans;
		}
	}
	
//
//  5
//	4
//  9
//
	
	int ansMade = -1;
	
	boolean gen(Value a, Value b, Value c, int pos, int carry, int using) {
		if (c.ar.length == pos && carry == 0) {
			if (using == 0) {
				ansMade = Math.max(a.getMinBase(), Math.max(b.getMinBase(), c.getMinBase()));
			} else {
				ansMade = using;
			}
			return true;
		}
		if (c.ar.length == pos && carry != 0) {
			return false;
		}
		int sum = a.getValue(pos) + b.getValue(pos) + carry;
		if (using != 0) {
			carry = sum / using;
			sum %= using;

			if (sum != c.getValue(pos)) {
				return false;
			}
			return gen(a, b, c, pos + 1, carry, using);
		}
		if (sum < c.getValue(pos)) {
			return false;
		}
		if (sum == c.getValue(pos)) {
			return gen(a, b, c, pos + 1, 0, using);
		}
		for (int i = c.getValue(pos) + 1; i <= sum; i++) {
			if (sum % i == c.getValue(pos)) {
				if (gen(a, b, c, pos + 1, sum / i, i)) {
					return true;
				}
			}
		}
		return false;
	}
	
	void solve() {
		String s = in.next();
		int plusIdx = s.indexOf("+");
		int eqIdx = s.indexOf("=");
		Value a = new Value(s.substring(0, plusIdx).toCharArray());
		Value b = new Value(s.substring(plusIdx+1, eqIdx).toCharArray());
		Value c = new Value(s.substring(eqIdx+1).toCharArray());
		
		asserT(gen(a, b, c, 0, 0, 0));
		out.println(ansMade);
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	public void run() {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
	
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new AlexSolution().run();
	}
}
