const 
  MAXLEN = 9;
  INF = 1E9;

type
  TLongNum = record
    size: integer;
    digits: array[1..MAXLEN] of integer;
  end;


//          ( x), 
//        
function readNumber(var x: TLongNum): integer;
var
  ch: char;
  base: integer;
begin
  base := 2;
  with x do
  begin
    size := 0;
    ch := #0;
    while not (ch in ['0'..'9', 'A'..'Z']) do 
      read(ch);
    while ch in ['0'..'9', 'A'..'Z']  do 
    begin
      inc(size);
      if ch in ['0'..'9'] then 
        digits[size] := ord(ch) - ord('0')
      else
        digits[size] := ord(ch) - ord('A') + 10;
      if digits[size] >= base then
        base := digits[size] + 1;
      read(ch);
     end;
  end;  
  readNumber := base;
  if x.size > 9 then begin
    writeln('ERROR IN TEST');
    halt(1);
  end;
end;

//        Int64 
//(   Int64  )
function longNum2Int64(const x: TLongNum; base: integer) : Int64;
var
  i: integer;
  res: Int64;
begin
  res := 0;
  with x do
    for i := 1 to size do
      res := res * base + digits[i];
  longNum2Int64 := res;
end;

var
  base, nextbase: integer;
  a, b, c: TLongNum;       

begin
  base := 2;
  nextbase := readNumber(a);
  if nextbase > base then  base := nextbase;
  nextbase := readNumber(b);
  if nextbase > base then base := nextbase;
  nextbase := readNumber(c);
  if nextbase > base then base := nextbase;
  while longNum2Int64(a, base)+longNum2Int64(b, base)<>longNum2Int64(c, base) do 
    inc (base);
  writeln(base);
end.
