import java.io.*;
import java.util.*;

public class AlexSolution {
	
	Scanner in;
	static PrintWriter out;
	
	static class Point implements Comparable<Point> {
		int x;
		int y;
		int dist;
		
		Point(Scanner in) {
			this.x = in.nextInt();
			this.y = in.nextInt();
			this.dist = x * x + y * y;
		}
				
		Point(final int x, final int y) {
			this.x = x;
			this.y = y;
			if (x < 0) {
				this.x = -x;
				this.y = -y;
			} else if (x == 0) {
				this.y = 1;
			}
		}
		
		@Override
		public int compareTo(Point other) {
			if (this.x != other.x) {
				return this.x - other.x;
			} else {
				return this.y - other.y;
			}
		}
		
		public String toString() {
			return x + " " + y;
		}
	}
	
	int gcd(int a, int b) {
		if (b == 0) {
			return a;
		} else {
			return gcd(b, a%b);
		}
	}
	
	Map<Point, Set<Point>> map = new TreeMap<Point, Set<Point>>();
	
	void addToMap(Point p, Point p1, Point p2) {
		if (!map.containsKey(p)) {
			map.put(p, new TreeSet<Point>());
		}
		asserT(map.get(p).add(p1));
		if (p1 != p2) {
			asserT(map.get(p).add(p2));
		}
	}
	
	void solve() {
		in.nextInt();
		int count = in.nextInt();
		List<Point> ar = new ArrayList<Point>();
		
		for (int i = 0; i < count; i++) {
			Point p = new Point(in);
			
			if (p.x == 0 && p.y == 0) {
				
			} else {
				ar.add(p);
				
				int sumX = p.x;
				int sumY = p.y;
				
				int div = gcd(Math.abs(sumX), Math.abs(sumY));
				
				sumX /= div;
				sumY /= div;
				
				addToMap(new Point(sumX, sumY), p, p);
			}
		}
		count = ar.size();
		for (int i = 0; i < count; i++) {
			Point first = ar.get(i);
			for (int j = i + 1; j < count; j++) {
				Point second = ar.get(j);
				if (first.x == second.x && first.y == second.y) {
					throw new Error();
				}
				
				if (first.dist == second.dist) {
					int sumX = first.x + second.x;
					int sumY = first.y + second.y;
					
					if (sumX == 0 && sumY == 0) {
						if (first.x == 0) {
							//   
							sumX = 1;
							sumY = 0;
						} else if (first.y == 0) {
							//   
							sumX = 0;
							sumY = 1;
						} else {
							//   90  
							sumX = -first.y;
							sumY = first.x;
						}
					} 
					int div = gcd(Math.abs(sumX), Math.abs(sumY));
					
					sumX /= div;
					sumY /= div;
					
					addToMap(new Point(sumX, sumY), first, second);
				}
			}
		}
		int best = 0;
		for (Set<Point> pnt : map.values()) {
			best = Math.max(best, pnt.size());
		}
		out.println(ar.size() - best);
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	public void run() {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
	
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new AlexSolution().run();
	}
}
