const 
  NMAX = 5000;
  RMAX = 1000;

type

Point = record
  x, y, r2: longint;
end;

Line = record
   a, b: longint; 	
end;

{訩 騩 ⥫}
function gcd(a, b: longint) : longint;
var
  c: longint;
begin
  a := abs(a); b := abs(b);
  while b > 0 do begin
    c := a mod b; a := b; b := c;
  end;
  gcd := a;
end;

{ଠ ࠬ a  b  ࠢ אַ  ax+by=0}
procedure Normalize(var l: Line);
var
  d: longint;
begin
  with l do begin
    if a = 0 then begin b := 1; exit; end;
    if b = 0 then begin a := 1; exit; end;
    if a < 0 then begin 
      a := -a; b := -b; 
    end;
    d := gcd(a, b);
    a := a div d; 
    b := b div d;
  end;
end;

{  ࠬ a  b ࠢ אַ 
 ax+by=0, 室饩 १  p }
procedure MakeLineByPoint(p: Point; var l: Line);
begin
  l.a := -p.y;
  l.b := p.x;
  Normalize(l);
end;

{   ࠬ a  b ࠢ אַ 
 ax+by=0, ௥୮ १ p1 - p2 }
procedure MakeLineBetweenPoints(p1, p2: Point; var l: Line);
begin
  l.a := p2.x - p1.x;
  l.b := p2.y - p1.y;
  Normalize(l);
end;

var
  lines: array[0..2*RMAX, -2*RMAX..2*RMAX] of word;
  points: array[1..NMAX] of Point;
  l: line;
  r, n, i, j, ans, x, y: longint;

begin
  read(r, n);
  j := 0;
  for i := 1 to n do begin
    read(x, y);
    if (x <> 0) or (y <> 0) then
    begin
      inc(j);
      points[j].x := x; 
      points[j].y := y;
      points[j].r2 := sqr(points[j].x) + sqr(points[j].y);
    end;
  end;
  n := j;
  for i := 0 to 2*r do
    for j := -2*r to 2*r do
      lines[i][j] := 0;

  for i := 1 to n do 
  begin
    MakeLineByPoint(points[i], l);
    inc(lines[l.a][l.b]);
  end;

  for i := 1 to n - 1 do 
    for j := i + 1 to n do 
      if points[i].r2 = points[j].r2 then
      begin 
        MakeLineBetweenPoints(points[i], points[j], l);
        inc(lines[l.a][l.b], 2);
      end;

  ans := 0;
  for i := 0 to 2*r do
    for j := -2*r to 2*r do
       if lines[i][j] > ans then
         ans := lines[i][j];
  writeln(n - ans);
end.
