import java.io.*;

public class Main {
	
	Scanner in;
	static PrintWriter out;
	
	static class Scanner {
		StreamTokenizer in;
		
		Scanner(InputStream is) {
			in = new StreamTokenizer(new BufferedReader(new InputStreamReader(is)));
			in.resetSyntax();
			in.whitespaceChars(0, 32);
			in.wordChars(33, 255);
		}
		
		int nextInt() {
			try {
				in.nextToken();
				return Integer.parseInt(in.sval);
			} catch (IOException e) {
				throw new Error();
			}
		}
	}

	void solveSmart() {
		int total = in.nextInt();
		asserT(1 <= total && total <= 1000);
		int maxTaken = in.nextInt();
		asserT(1 <= maxTaken && maxTaken <= total);
		int paramsCount = in.nextInt();
		asserT(1 <= paramsCount && paramsCount <= 16);
		
		int []state = new int[total];
		for (int i = 0; i < total; i++) {
			state[i] = 0;
			for (int j = 0; j < paramsCount; j++) {
				int val = in.nextInt();
				if (val == 1) {
					state[i] |= (1 << j); 
				}
			}
		}
		maxTaken = Math.min(maxTaken, paramsCount);
		int [][]next = new int[maxTaken + 1][1 << paramsCount];
		for (int taken = 0; taken <= maxTaken; taken++) {
			for (int mask = 0; mask < next[taken].length; mask++) {
				int countOnes = 0;
				for (int i = 0; i < paramsCount; i++) {
					int val = mask & (1 << i);
					if (val == (1 << i)) {
						countOnes++;
					}
				}
				next[taken][mask] = countOnes;
			}
		}
		int [][]curr = new int[maxTaken + 1][1 << paramsCount];
		for (int i = total - 1; i >= 0; i--) {
			for (int taken = 0; taken <= maxTaken; taken++) {
				for (int mask = 0; mask < curr[taken].length; mask++) {
					curr[taken][mask] = next[taken][mask];
					if (taken < maxTaken) {
						int res = next[taken + 1][mask | state[i]];
						curr[taken][mask] = Math.max(curr[taken][mask], res);
					}
				}
			}
			int [][]temp = curr;
			curr = next;
			next = temp;
		}
		out.println(next[0][0]);
	}
		
	void solve() {
		solveSmart();
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	public void run() {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
	
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new Main().run();
	}
}