import java.io.*;
import java.util.*;

public class Greedier {
	
	Scanner in;
	static PrintWriter out;
	
	int getOnesCount(int value, int bits) {
		int countOnes = 0;
		for (int i = 0; i < bits; i++) {
			int val = value & (1 << i);
			if (val == (1 << i)) {
				countOnes++;
			}
		}
		return countOnes;
	}
	
	void solveGreedy(int total, int maxTaken, final int paramsCount, int []state) {
		maxTaken = Math.min(maxTaken, paramsCount);
		Integer sorted[] = new Integer[state.length];
		for (int i = 0; i < state.length; i++) {
			sorted[i] = state[i];
		}
		Arrays.sort(sorted, new Comparator<Integer>() {
			@Override
			public int compare(Integer first, Integer second) {
				return - getOnesCount(first, paramsCount) + getOnesCount(second, paramsCount);
			}
		});
		for (int i = 0; i < state.length; i++) {
			state[i] = sorted[i];
		}
		int bestCount = 0;
		for (int first = 0; first < total; first++) {
			int currValue = state[first];
			int idx = first + 1;
			int taken = 1;
			while (idx < total && taken < maxTaken) {
				int usingThis = currValue | state[idx];
				if (usingThis != currValue) {
					currValue = usingThis;
					taken++;
				}
				idx++;
			}
			bestCount = Math.max(bestCount, getOnesCount(currValue, paramsCount));
		}
		out.println(bestCount);
	}
	
	void solve() {
		int total = in.nextInt();
		asserT(1 <= total && total <= 1000);
		int maxTaken = in.nextInt();
		asserT(1 <= maxTaken && maxTaken <= total);
		int paramsCount = in.nextInt();
		asserT(1 <= paramsCount && paramsCount <= 12);
		
		int []state = new int[total];
		for (int i = 0; i < total; i++) {
			state[i] = 0;
			for (int j = 0; j < paramsCount; j++) {
				int val = in.nextInt();
				if (val == 1) {
					state[i] |= (1 << j); 
				}
			}
		}
		
		solveGreedy(total, maxTaken, paramsCount, state);
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	public void run() {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
	
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new Greedier().run();
	}
}