import java.io.*;
import java.util.*;

public class Naive {
	
	Scanner in;
	static PrintWriter out;
	
	int getOnesCount(int value, int bits) {
		int countOnes = 0;
		for (int i = 0; i < bits; i++) {
			int val = value & (1 << i);
			if (val == (1 << i)) {
				countOnes++;
			}
		}
		return countOnes;
	}
	
	void solveNaive(int total, int maxTaken, int paramsCount, int []state) {
		maxTaken = Math.min(maxTaken, paramsCount);
		int best = 0;
		for (int i = 0; i < 1000000; i++) {
			int curr = 0;
			for (int taken = 0; taken < maxTaken; taken++) {
				int random = (int)((long)(Math.random() * 1000000) % total);
				curr |= state[random];
			}
			curr = getOnesCount(curr, paramsCount);
			best = Math.max(best, curr);
		}
		out.println(best);
	}
	
	void solve() {
		int total = in.nextInt();
		asserT(1 <= total && total <= 1000);
		int maxTaken = in.nextInt();
		asserT(1 <= maxTaken && maxTaken <= total);
		int paramsCount = in.nextInt();
		asserT(1 <= paramsCount && paramsCount <= 16);
		
		int []state = new int[total];
		for (int i = 0; i < total; i++) {
			state[i] = 0;
			for (int j = 0; j < paramsCount; j++) {
				int val = in.nextInt();
				if (val == 1) {
					state[i] |= (1 << j); 
				}
			}
		}
		solveNaive(total, maxTaken, paramsCount, state);
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	public void run() {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
	
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new Naive().run();
	}
}